local htmlTexture = require("htmlTexture")

local M = {}
M.isRightSkin = false
M.isInit = false
M.lastPaint = {}
M.currentPaint = {}

local function initLivery()
    htmlTexture.create("@dynamic_livery", "local://local/vehicles/common/dynamic_livery.html", 2048, 2048, 0, "manual")
    htmlTexture.call("@dynamic_livery", "init")
    local modelName = v.config.model or v.config.mainPartName
    obj:queueGameEngineLua("extensions.BeamPaint.setLiveryUsed(" .. obj:getID() .. ", \"" .. modelName .. "\")")
end

local function onExtensionLoaded()
    M.isRightSkin = v.config.parts.paint_design == "global_skin_dynamic"
    M.isRightSkin = M.isRightSkin or v.config.parts.skin_lbe == "global_skin_dynamic_lbe"
    if M.isRightSkin then
        initLivery() -- TODO: Only init when the vehicle has the parts
        M.isInit = true
        obj:queueGameEngineLua("extensions.BeamPaint.updatePlayerVehiclePaint(" .. obj:getID() .. ")")
    end
end

local function updateLivery(src, needsGammaCorrection)
    local data = {}
    data.src = src
    data.needsGammaCorrection = needsGammaCorrection
    htmlTexture.call("@dynamic_livery", "updateLivery", data)
end

local function updateGFX(dt)
    if M.isRightSkin then
        if M.lastPaint ~= M.currentPaint and M.isInit then
            M.lastPaint = M.currentPaint
            local data = M.currentPaint
            htmlTexture.call("@dynamic_livery", "updatePaint", data)
        end
    end
end

local function updateCurrentPaint(r,g,b)
    M.currentPaint = {}
    M.currentPaint.baseColor = {r,g,b}
end

M.onExtensionLoaded = onExtensionLoaded
M.updateLivery = updateLivery
M.updateGFX = updateGFX
M.updateCurrentPaint = updateCurrentPaint

return M
